	.file	"swtch.s"
	.text
	.align	2
	.globl	_swtch__6ThreadFv
_swtch__6ThreadFv:
	#
	# _au0_this is in 4(%esp) at entry.
	# No need to save scratch registers since preemption code does that.
	#
	pushl	%ebp
	movl	%esp, %ebp
#ifdef FPU_PREEMPT
	#
	#	WARNING: The following offsets depend on the setup of class
	#		 Thread and all those from which it is derived
	#
	movl	8(%ebp), %eax		# eax == "this"
	movl   	32(%eax), %ecx		# ecx = this->usingfpu

	pushl	%edi
	pushl	%esi
	pushl	%ebx

	cmpl	$0, %ecx		# is this guy using fpu context?
	je	no_fpu_save		# nope
	leal	-108(%esp), %esp	# save it...
	fsave	(%esp)			# ... on stack
no_fpu_save:
	pushl	%ecx			# save this->usingfpu for restore

	movl	$0, _interrupts_enabled;
	xchgl	%esp, 20(%eax)		# swap stack-pointer with thread
	xchgl	%ebp, 24(%eax)		# swap frame-pointer with thread
	movb	$1, _interrupts_enabled;

	popl	%ecx			# ecx = newguy->usingfpu
	cmpl	$0, %ecx		# restore fpu context for new guy?
	je	no_fpu_restore		# nope
	frstor	(%esp)			# restore it...
	leal	108(%esp), %esp		# ... from stack
no_fpu_restore:
	# fall through to popping normal registers, return
#else /* FPU_PREEMPT */
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	#
	#	WARNING: The following offsets depend on the setup of class
	#		 Thread and all those from which it is derived
	#
	movl	$0, _interrupts_enabled;

	movl	8(%ebp), %eax		# eax == "this"
	xchgl	%esp, 20(%eax)		# swap stack-pointer with thread
	xchgl	%ebp, 24(%eax)		# swap frame-pointer with thread

	movb	$1, _interrupts_enabled;
	#
	# restore regs
	#
#endif /* FPU_PREEMPT */
	popl	%ebx
	popl	%esi
	popl	%edi
	leave
	ret

/*
 * init_stack(Thread* newthread, int* new_stack_top)
 *	Push a proper "swtch" register context, so next swtch() in
 *	newthread restores registers correctly and returns to caller's caller.
 *	Save apprioriate stack and frame pointer in thread.
 *
 * Called in Thread::runrun().
 *
 * Assumes caller has no register variables, thus current contents are
 * appropriate for caller's caller.
 */	
	.text
	.align	2
	.globl	_init_stack
_init_stack:
	popl	%ecx		# ecx = return address
	popl	%eax		# eax -> thread
	popl	%edx		# edx = new stack top
	pushl	%edi		# push registers ...
	pushl	%esi		#	... ala swtch()
	pushl	%ebx		#		... entry.
#ifdef FPU_PREEMPT
	pushl	$0		# push fake value for thread->usingfpu
				# always push 0 initially so that first
				# restore won't needlessly load nonexistent
				# fpu context (especially since we didn't
				# dummy up one of those anyway...)
#endif /* FPU_PREEMPT */
	movl	%esp, 20(%eax)	# save callers stack pointer in thread
	movl	%ebp, 24(%eax)	# save callers frame pointer in thread
	leal	-8(%edx), %esp	# on new stack, room for caller to pop args
	jmp	*%ecx		# return
