/*
 * Switch routines
 *
 *	save all registers (including fpu context on i386 when appropriate)
 *	disable interrupts
 *	remember current sp and fp
 *	restore old sp and fp
 *	enable interrupts
 *	restore old registers on return (including fpu context as above)
 */

/*
 *	Context Switch
 *
 *	This routine must be atomic (nonpreemptable).
 */

#ifdef	ns32000
#include "ns32000_swtch.s"
#endif

#ifdef	i386
#include "i386_swtch.s"
#endif /* i386 */

#ifdef vax
#include "vax_swtch.s"
#endif /* vax */


#ifdef mc68020
#include "68020_swtch.s"
#endif /* mc68020 */

#ifdef mips
#include "mips_swtch.s"
#endif /* mips */

